import pickle
import os

levels_cache = None
pickle_filename = os.path.join(os.path.dirname(__file__), "Achivements.dat")

def check_cache():
	global levels_cache
	if levels_cache == None:
		try:
			levels_cache = pickle.load(file(pickle_filename,"rb"))
		except:
			levels_cache = {}

def get_time_trophy(parameters, time_to_complete):
	if time_to_complete < parameters.GOLDEN_TROPHY_TIME:
		return 3,None
	elif time_to_complete < parameters.SILVER_TROPHY_TIME:
		return 2,parameters.GOLDEN_TROPHY_TIME
	else:
		return 1,parameters.SILVER_TROPHY_TIME

def get_feathers_trophy(parameters, feathers_count):
	if feathers_count > parameters.GOLDEN_TROPHY_FEATHERS:
		return 3,None
	elif feathers_count > parameters.SILVER_TROPHY_FEATHERS:
		return 2,parameters.GOLDEN_TROPHY_FEATHERS
	else:
		return 1,parameters.SILVER_TROPHY_FEATHERS

def get_height_trophy(parameters, maximum_height):
	if maximum_height > parameters.GOLDEN_TROPHY_HEIGHT:
		return 3,None
	elif maximum_height > parameters.SILVER_TROPHY_HEIGHT:
		return 2,parameters.GOLDEN_TROPHY_HEIGHT
	else:
		return 1,parameters.SILVER_TROPHY_HEIGHT

def won_level(index, parameters, time_to_complete, feathers_count, maximum_height):
	check_cache()
	
	if index in levels_cache:
		level_data = levels_cache[index]
	else:
		level_data = {
			"time_trophy":0,
			"time_to_complete":9999999,
			"feather_trophy":0,
			"feather_collected":0,
			"height_trophy":0,
			"height_reached":0,
			}
	
	if time_to_complete < level_data["time_to_complete"]:
		level_data["time_to_complete"] = time_to_complete
	level_data["time_trophy"] = get_time_trophy(parameters, level_data["time_to_complete"])
	
	if feathers_count > level_data["feather_collected"]:
		level_data["feather_collected"] = feathers_count
	level_data["feather_trophy"] = get_feathers_trophy(parameters, level_data["feather_collected"])
	
	if maximum_height > level_data["height_reached"]:
		level_data["height_reached"] = maximum_height
	level_data["height_trophy"] = get_height_trophy(parameters, level_data["height_reached"])
	
	levels_cache[index] = level_data
	
	try:
		pickle.dump(levels_cache, file(pickle_filename,"wb"))
	except:
		print "Could not store winning data!"

def get_trophys(index):
	check_cache()
	
	if index in levels_cache:
		level_data = levels_cache[index]
		accomplishments = []
		
		text = "You finished in %d seconds" % level_data["time_to_complete"]
		extra_text = ""
		if level_data["time_trophy"][1] != None:
			extra_text = "Finish in %d seconds for another trophy" % level_data["time_trophy"][1]
		accomplishments.append((level_data["time_trophy"][0],text,extra_text))
		
		text = "You have collected %d feathers" % level_data["feather_collected"]
		extra_text = ""
		if level_data["feather_trophy"][1] != None:
			extra_text = "Collect %d feathers for another trophy" % level_data["feather_trophy"][1]
		accomplishments.append((level_data["feather_trophy"][0],text,extra_text))
		
		text = "You have reached a height of %d feet" % level_data["height_reached"]
		extra_text = ""
		if level_data["height_trophy"][1] != None:
			extra_text = "Reach the height of %d feet for another trophy" % level_data["height_trophy"][1]
		accomplishments.append((level_data["height_trophy"][0],text,extra_text))
		
		return accomplishments
	else:
		text = "You didn't play this level yet"
		extra_text = ""
		return [(0,text,extra_text),(0,text,extra_text),(0,text,extra_text)]