import level
import random

class Level1(level.Parameters):
	LevelName = "Level 1 - Introduction"
	WORLD_WIDTH = 3*800
	@staticmethod
	def add_init_platforms(platforms):
		platforms.append(level.Platform(-160,False))
		platforms.append(level.Platform((2.7)*800,True))

class Level2(level.Parameters):
	LevelName = "Level 2 - Work zone"
	TIME_BETWEEN_BIRDS = 0.3
	GOLDEN_TROPHY_FEATHERS = 150
	SILVER_TROPHY_FEATHERS = 100

class Level3(level.Parameters):
	LevelName = "Level 3 - Hot wings"
	TIME_BETWEEN_BIRDS = 1.0
	BIRDS_SPEED = 265.0 #pixels/second

class Level4(level.Parameters):
	LevelName = "Level 4 - High roller"
	MAX_TEMPERATURE_HEIGHT = 3300
	MIN_TEMPERATURE_HEIGHT = 400
	SUN_POSITION = 5000
	GOLDEN_TROPHY_HEIGHT = 6000
	SILVER_TROPHY_HEIGHT = 5000
	
	TIME_BETWEEN_BIRDS = 0.2
	@staticmethod
	def add_bird(birds, icarus_position_x, icarus_position_y,speed):
		birds.append(level.Bird(icarus_position_x+random.randint(900,4000),random.randint(1000,5000), level.Colors.BLUE,speed))

class Level5(level.Parameters):
	LevelName = "Level 5 - Long way to go"
	WORLD_WIDTH = 12*800
	
	GOLDEN_TROPHY_TIME = 60
	SILVER_TROPHY_TIME = 70
	
	@staticmethod
	def add_init_platforms(platforms):
		platforms.append(level.Platform(-160,False))
		platforms.append(level.Platform(660,False))
		platforms.append(level.Platform(1860,False))
		platforms.append(level.Platform(1960,False))
		platforms.append(level.Platform(6960,False))
		platforms.append(level.Platform((11.7)*800,True))

levels = [Level1, Level2, Level3, Level4, Level5]

def load_level(index):
	return level.Level(levels[index])
